#line 1 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
#line 1 "c:/program files/mikroelektronika/mikroc pro for dspic/uses/__ethenc28j60.h"
#line 119 "c:/program files/mikroelektronika/mikroc pro for dspic/uses/__ethenc28j60.h"
typedef struct
 {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
 } SPI_Ethernet_arpCacheStruct;

extern SPI_Ethernet_arpCacheStruct SPI_Ethernet_arpCache[];

extern unsigned char SPI_Ethernet_macAddr[6];
extern unsigned char SPI_Ethernet_ipAddr[4];
extern unsigned char SPI_Ethernet_gwIpAddr[4];
extern unsigned char SPI_Ethernet_ipMask[4];
extern unsigned char SPI_Ethernet_dnsIpAddr[4];
extern unsigned char SPI_Ethernet_rmtIpAddr[4];

extern unsigned long SPI_Ethernet_userTimerSec;

typedef struct {
 unsigned canCloseTCP: 1;
 unsigned isBroadcast: 1;
} TEthPktFlags;
#line 146 "c:/program files/mikroelektronika/mikroc pro for dspic/uses/__ethenc28j60.h"
extern void SPI_Ethernet_Init(unsigned char *resetPort, unsigned char resetBit, unsigned char *CSport, unsigned char CSbit, unsigned char *mac, unsigned char *ip, unsigned char fullDuplex);
extern unsigned char SPI_Ethernet_doPacket();
extern void SPI_Ethernet_putByte(unsigned char b);
extern void SPI_Ethernet_putBytes(unsigned char *ptr, unsigned int n);
extern void SPI_Ethernet_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char SPI_Ethernet_getByte();
extern void SPI_Ethernet_getBytes(unsigned char *ptr, unsigned int addr, unsigned int n);
extern unsigned int SPI_Ethernet_UserUDP(unsigned char *remoteHost, unsigned int remotePort, unsigned int localPort, unsigned int reqLength, TEthPktFlags * flags);
extern unsigned int SPI_Ethernet_UserTCP(unsigned char *remoteHost, unsigned int remotePort, unsigned int localPort, unsigned int reqLength, TEthPktFlags * flags);
extern void SPI_Ethernet_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);
#line 14 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
sfr sbit SPI_Ethernet_Rst at LATF0_bit;
sfr sbit SPI_Ethernet_CS at LATF1_bit;
sfr sbit SPI_Ethernet_Rst_Direction at TRISF0_bit;
sfr sbit SPI_Ethernet_CS_Direction at TRISF1_bit;




const unsigned char httpHeader[] = "HTTP/1.1 200 OK\nContent-type: ";
const unsigned char httpMimeTypeHTML[]= "text/html; charset=iso-8859-7\n\n";
const unsigned char httpMimeTypeScript[] = "text/plain\n\n";
unsigned char httpMethod[] = "GET /";




unsigned char myMacAddr[6] = {0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};
unsigned char myIpAddr[4] = {192, 168, 0, 70 };
unsigned char gwIpAddr[4] = {192, 168, 0, 1 };
unsigned char ipMask[4] = {255, 255, 255, 0 };
unsigned char dnsIpAddr[4] = {192, 168, 0, 1 };

unsigned char getRequest[15];
unsigned char dyna[30];
unsigned long httpCounter = 0;


unsigned long eeAddr = 0x7FFC30;


int AirSpeedTick=0;
int AirSpeed=0;
int AirSpeedCoficient=9;
int PreviusAirSpeed=0;
int AverageAirSpeed=0;
int MaxAirSpeed=0;
int MinAirSpeed=0;
int ZeroSpeedCounter=0;

int TickCounter=0 ;
int minutes=0;

int Temp[4];
int TempTick=0;
char integTemp=0;
char decimTemp=0;

char integHum=0;
char decimHum=0;
char checksum=0;

 char txt[4];

int LastQuarterSpeed[20];


int ALeds[4];
unsigned char Dlogo[]="-----";
#line 88 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
unsigned int SPI_Ethernet_UserTCP(unsigned char *remoteHost, unsigned int remotePort,
 unsigned int localPort, unsigned int reqLength, TEthPktFlags *flags) {
 unsigned int len = 0 ;
 unsigned int i ;






 if(localPort != 90) {
 return(0) ;
 }


 for(i = 0 ; i < 10 ; i++) {
 getRequest[i] = SPI_Ethernet_getByte() ;
 }
 getRequest[i] = 0 ;

 if(memcmp(getRequest, httpMethod, 5)) {
 return(0) ;
 }

 httpCounter++ ;

 if(getRequest[5] == 's') {



 len =  SPI_Ethernet_putConstString (httpHeader) ;
 len +=  SPI_Ethernet_putConstString (httpMimeTypeScript);



 IntToStr(ALeds[0], dyna) ; len +=  SPI_Ethernet_putConstString ("RB0") ; len +=  SPI_Ethernet_putString (dyna) ;
 InttoStr(ADC1_Read(0),dyna); len +=  SPI_Ethernet_putString ("  Real value = " ) ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 IntToStr(ALeds[1], dyna) ; len +=  SPI_Ethernet_putConstString ("RB1") ; len +=  SPI_Ethernet_putString (dyna) ;
 InttoStr(ADC1_Read(01),dyna); len +=  SPI_Ethernet_putString ("  Real value = " ) ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 IntToStr(ALeds[2], dyna) ; len +=  SPI_Ethernet_putConstString ("RB2") ; len +=  SPI_Ethernet_putString (dyna) ;
 InttoStr(ADC1_Read(02),dyna); len +=  SPI_Ethernet_putString ("  Real value = " ) ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 IntToStr(ALeds[3], dyna) ; len +=  SPI_Ethernet_putConstString ("RB3") ; len +=  SPI_Ethernet_putString (dyna) ;
 InttoStr(ADC1_Read(3),dyna); len +=  SPI_Ethernet_putString ("  Real value = " ) ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 IntToStr(AirSpeed, dyna) ; len +=  SPI_Ethernet_putConstString ("Air Speed Tick") ; len +=  SPI_Ethernet_putString (dyna) ;
 InttoStr(AirSpeedTick,dyna); len +=  SPI_Ethernet_putString ("value = " ) ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 len +=  SPI_Ethernet_putConstString ("Air Speed Cof value = ") ; InttoStr(AirSpeedCoficient,dyna); len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 len +=  SPI_Ethernet_putConstString ("AirSpeed value = ") ; IntToStr(AirSpeed, dyna) ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;


 ByteToStr(integTemp, dyna) ; len +=  SPI_Ethernet_putConstString ("Temp ") ; len +=  SPI_Ethernet_putString (dyna) ;
 ByteToStr(decimTemp, dyna) ; len +=  SPI_Ethernet_putConstString (",") ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;



 ByteToStr(integHum, dyna) ; len +=  SPI_Ethernet_putConstString ("Humidity ") ; len +=  SPI_Ethernet_putString (dyna) ;
 ByteToStr(decimHum, dyna) ; len +=  SPI_Ethernet_putConstString (",") ; len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";\n") ;



 IntToStr(httpCounter, dyna) ;
 len +=  SPI_Ethernet_putConstString ("  REQ=") ;
 len +=  SPI_Ethernet_putString (dyna) ;

 len +=  SPI_Ethernet_putConstString ("\n to change Air Speed cof:  URL/t18\n") ;
 len +=  SPI_Ethernet_putConstString (";") ;
 }

 else if(getRequest[5] == 't') {
 unsigned char AirCof[20];
 int NumAirCof=0;
 len =  SPI_Ethernet_putConstString (httpHeader) ;
 len +=  SPI_Ethernet_putConstString (httpMimeTypeScript);

 if(isdigit(getRequest[6])) {
 Aircof[0]=getRequest[6] ;
 AirCof[1]=getRequest[7];
 NumAirCof=atoi(AirCof);
 AirSpeedCoficient=NumAircof;
 EEPROM_Write(eeAddr,NumAirCof);
 len +=  SPI_Ethernet_putConstString ("AirSpeedCoficient written in eeprom is = ") ;
 for (i=9;i<10;i++){
 intToStr(NumAirCof, dyna) ; len +=  SPI_Ethernet_putString (dyna) ;

 }


 }else{
 len +=  SPI_Ethernet_putConstString ("AirSpeedCoficient not set") ;
 }
 len +=  SPI_Ethernet_putConstString ("----\n") ;
 }


 if(len == 0) {

 len= SPI_Ethernet_putConstString ("HTTP/1.1 200 OK\n Content-type:text/html; charset=UTF-8 \n\n <html><body>");


 len +=  SPI_Ethernet_putConstString ("<p mode=\"wrap\" align=\"center\"> <a href=/>Reload</a></p>");
 len +=  SPI_Ethernet_putConstString ("<table border=\"1\" bordercolor=\"black\" cellspacing=\"2\" cellpadding=\"2\" height=\"100\" align=\"center\">");
 len +=  SPI_Ethernet_putConstString ("<tr bordercolor=\"#0000CC\" bgcolor=\"#948ACC\" style=\"font: normal 12pt Arial; text-align: center\">");
 len +=  SPI_Ethernet_putConstString ("<td></td>");
 len +=  SPI_Ethernet_putConstString ("<td></td>");
 len +=  SPI_Ethernet_putConstString ("<td></td>");
 len +=  SPI_Ethernet_putConstString ("<td></td>");
 len +=  SPI_Ethernet_putConstString ("</tr>");
 len +=  SPI_Ethernet_putConstString ("<tr bordercolor=\"#0000CC\" style=\"font: normal  bold 14pt Arial; text-align: center\">");
 len +=  SPI_Ethernet_putConstString ("<td>");ByteToStr(integTemp,txt);len +=  SPI_Ethernet_putString (txt);
 len +=  SPI_Ethernet_putString (" C</td>");
 len +=  SPI_Ethernet_putConstString ("<td>o ");IntToStr(MaxAirSpeed, dyna) ;len +=  SPI_Ethernet_putString (dyna) ; len +=  SPI_Ethernet_putString ("</td>");

 len +=  SPI_Ethernet_putConstString ("<td>");len +=  SPI_Ethernet_putString (Dlogo);len +=  SPI_Ethernet_putString ("</td>");

 len +=  SPI_Ethernet_putConstString ("<td>");
 len +=  SPI_Ethernet_putString ("----");
 len +=  SPI_Ethernet_putString (" %</td> </tr>");
 len +=  SPI_Ethernet_putConstString ("<tr bordercolor=\"#0000CC\" style=\"font: normal  bold 14pt Arial; text-align: center\"><td>  </td> <td> ");
 IntToStr(AverageAirSpeed, dyna) ;len +=  SPI_Ethernet_putString (dyna) ;len +=  SPI_Ethernet_putConstString (" Km/H</td><td>  </td><td>  </td></tr>");
 len +=  SPI_Ethernet_putConstString ("<tr bordercolor=\"#0000CC\" style=\"font: normal  bold 14pt Arial; text-align: center\"><td>  </td> <td>o "); IntToStr(MinAirSpeed, dyna) ;len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (" </td> <td>  </td> <td>  </td> </tr>");

 len +=  SPI_Ethernet_putConstString ("</table>");
 len +=  SPI_Ethernet_putConstString ("<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" height=\"30\" align=\"center\">");
 len +=  SPI_Ethernet_putConstString ("<tr  bgcolor=\"#948ACC\" style=\"font: normal 12pt courier; text-align: center\">");
 for (i=0;i<15;i++){
 len +=  SPI_Ethernet_putConstString ("<td>"); IntToStr(LastQuarterSpeed[i],dyna); len +=  SPI_Ethernet_putString (dyna) ; len +=  SPI_Ethernet_putString ("</td>");
 }
 len +=  SPI_Ethernet_putConstString ("</tr><tr><td>@Kalarakis.gr</td></tr></table>");
 len +=  SPI_Ethernet_putConstString ("</body></html>");
 }

 return(len) ;
}
#line 253 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
unsigned int SPI_Ethernet_UserUDP(unsigned char *remoteHost, unsigned int remotePort,
 unsigned int destPort, unsigned int reqLength, TEthPktFlags *flags) {
 return 0;
}






 void ReadValues(){

 ALeds[0]=ADC1_Read(0);
 ALeds[1]=ADC1_Read(1);
 ALeds[2]=ADC1_Read(2);
 ALeds[3]=ADC1_Read(3);

 }

void NormalizeValues(){

 int i;
 int Temp;
 for (i=0;i<5;i++){
 Temp=Aleds[i];

 if(Temp>2000) {
 ALeds[i]=2000;
 continue;
 }
 if (Temp>=1000 && Temp<=1990) {
 ALeds[i]=1000;
 continue;
 }
 if (Temp>=300 && Temp<=999) {
 ALeds[i]=500;
 continue;
 }
 if(Temp<=299) {
 ALeds[i]=200;
 continue;
 }
 }

}

void SetAirDirection(){
 if ((ALeds[0]==500) && (ALeds[1]==200) && (ALeds[2]) ==500 && (ALeds[3]==2000)){strcpy(Dlogo," B  ");}
 if ((ALeds[0]==500) && (ALeds[1]==200) && (ALeds[2]) ==1000 && (ALeds[3]==2000)){strcpy(Dlogo,"B-A");}
 if (ALeds[0]==200 && ALeds[1]==200 && ALeds[2] ==2000 && ALeds[3]==2000){strcpy(Dlogo," BA ");}
 if (ALeds[0]==200 && ALeds[1]==200 && ALeds[2] ==2000 && ALeds[3]==1000){strcpy(Dlogo,"BA-");}

 if (ALeds[0]==200 && ALeds[1]==500 && ALeds[2] ==2000 && ALeds[3]==500) {strcpy(Dlogo," A  ");}

 if (ALeds[0]==200 && ALeds[1]==1000 && ALeds[2] ==2000 && ALeds[3]==500){ strcpy(Dlogo,"A-NA");}

 if (ALeds[0]==200 && ALeds[1]==2000 && ALeds[2] ==2000 && ALeds[3]==200){strcpy(Dlogo," NA");}
 if (ALeds[0]==500 && ALeds[1]==2000 && ALeds[2] ==2000 && ALeds[3]==200){strcpy(Dlogo,"NA-N");}
 if (ALeds[0]==500 && ALeds[1]==2000 && ALeds[2] ==1000 && ALeds[3]==200){strcpy(Dlogo,"N-NA");}
 if (ALeds[0]==500 && ALeds[1]==2000 && ALeds[2] ==500 && ALeds[3]==200) {strcpy(Dlogo," N  ");}

 if (ALeds[0]==1000 && ALeds[1]==2000 && ALeds[2] ==500 && ALeds[3]==200){strcpy(Dlogo,"N-N");}
 if (ALeds[0]==2000 && ALeds[1]==2000 && ALeds[2] ==500 && ALeds[3]==200){strcpy(Dlogo,"  ");}
 if (ALeds[0]==2000 && ALeds[1]==2000 && ALeds[2] ==500 && ALeds[3]==500) {strcpy(Dlogo,"-");}

 if (ALeds[0]==2000 && ALeds[1]==500 && ALeds[2] ==500 && ALeds[3]==500) {strcpy(Dlogo,"  ");}
 if (ALeds[0]==2000 && ALeds[1]==500 && ALeds[2] ==500 && ALeds[3]==1000) {strcpy(Dlogo,"-");}
 if (ALeds[0]==2000 && ALeds[1]==200 && ALeds[2] ==200 && ALeds[3]==2000){strcpy(Dlogo,"  ");}
 if (ALeds[0]==2000 && ALeds[1]==200 && ALeds[2] ==500 && ALeds[3]==2000){strcpy(Dlogo,"-");}
 if (ALeds[0]==1000 && ALeds[1]==200 && ALeds[2] ==500 && ALeds[3]==2000){strcpy(Dlogo,"-");}
}



void onTimer1Interupt() org 0x00001A {
 int i;
 IFS0bits.T1IF = 0;
 PORTDbits.RD3 = ~PORTDbits.RD3 ;
 TickCounter++;
 TempTick++;

 asm CLRWDT;


 if (TickCounter>4){
 ReadValues();
 NormalizeValues();
 SetAirDirection();

 AirSpeed=AirSpeedTick * 10 /AirSpeedCoficient;

 if (Airspeed >PreviusAirSpeed) {maxAirSpeed=(maxAirSpeed + Airspeed) /2;}
 if (AirSpeed < PreviusAirSpeed) {MinAirSpeed = (MinAirSpeed + AirSpeed) /2;}

 if (Airspeed >maxAirSpeed) {maxAirSpeed=Airspeed;}
 if (AirSpeed < MinAirSpeed) {MinAirSpeed = AirSpeed ;}

 AverageAirSpeed=(PreviusAirSpeed + Airspeed)/2;
 if (AverageAirSpeed==0) {maxAirSpeed=maxAirspeed /2;}
 PreviusAirspeed=AirSpeed;

 integTemp=ADC1_Read(8) /59;
 if (TempTick>240){

 for (i=0;i<14;i++){
 LastQuarterSpeed[i]= LastQuarterSpeed[i+1];
 }
 LastQuarterSpeed[14]= AverageAirSpeed;
 TempTick=0;
 }
 AirSpeedTick=0;
 TickCounter=0;
 }

}

 void OnINT0_Interupt() org 0x000014 {
 IFS0bits.INT0IF =0;
 AirSpeedTick++;

 }
#line 377 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
void main()
{ int i;
 ADPCFG |= 0xFF00;

 PORTB = 0;
 TRISB = 0xFFFF;

 PORTD = 0;
 TRISD = 0;

 ADC1_Init();

 AirSpeedCoficient=EEPROM_Read(eeAddr);
 if (AirSpeedCoficient <= 0){AirSpeedCoficient=10;}
 for (i=0;i<14;i++){
 LastQuarterSpeed[i]= 0;
 }
#line 401 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
 SPI1_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, _SPI_PRESCALE_SEC_5, _SPI_PRESCALE_PRI_16, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_IDLE_2_ACTIVE);
 SPI_Ethernet_Init(myMacAddr, myIpAddr,  0x01 ) ;
#line 415 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
 TMR1 = 0;
 PR1 =15625;
 IFS0bits.T1IF = 0;
 IEC0bits.T1IE = 1;
 T1CONbits.TCKPS=3;
 T1CONbits.TON=1;



 INTCON2bits.INT0EP=1;
 IEC0bits.INT0IE =1;

 while(1) {
#line 431 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
 SPI_Ethernet_doPacket() ;
#line 438 "D:/worksheet/controls/Robot/autonomo/Eagle/Anemometer 30F4013/code/anemometro.c"
 }
}
